//+------------------------------------------------------------------+
//|                                                Trailing Stop.mq5 |
//|                                  Copyright 2021, MetaQuotes Ltd. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2021, MetaQuotes Ltd."
#property link      "https://www.mql5.com"
#property version   "1.00"


#include <Trade\PositionInfo.mqh>
#include <Trade\Trade.mqh>
#include <Trade\SymbolInfo.mqh>
#include <Trade\OrderInfo.mqh>
#include <Trade\HistoryOrderInfo.mqh>
#include <Trade\DealInfo.mqh>


CSymbolInfo    o_symbol;
COrderInfo     o_order;   
CPositionInfo  o_position;
COrderInfo     o_history;   
CDealInfo      o_deal;
CTrade         Trade;
input int InpMagicNumber = 88;
input int tradeProfit = 100;
input double closePartial = 2;




//

void  ApplyTrailingStop() {
   string symbol = _Symbol;
   static int     digits   =  (int)SymbolInfoInteger(symbol, SYMBOL_DIGITS);
   
 
   // Trailing from the close prices
   double   buyStopLoss    =  iOpen(symbol,PERIOD_CURRENT,0);
   double   sellStopLoss   =  iOpen(symbol,PERIOD_CURRENT,0);
   double mainProfit = o_position.Swap() + o_position.Commission() + o_position.Profit();

   
   
 
   int      count          =  PositionsTotal();
   for (int i=count-1; i>=0; i--) {
      ulong ticket   =  PositionGetTicket(i);
      if (ticket>0) {
         if (PositionGetString(POSITION_SYMBOL)==symbol && PositionGetInteger(POSITION_MAGIC)==InpMagicNumber) {
            if (PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY && mainProfit >= tradeProfit ) {
               Trade.PositionClosePartial(ticket,closePartial);
               Trade.PositionModify(ticket, buyStopLoss, PositionGetDouble(POSITION_TP));
            } else
            if (PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL && mainProfit >= tradeProfit) {
               Trade.PositionClosePartial(ticket,closePartial);
               Trade.PositionModify(ticket, sellStopLoss, PositionGetDouble(POSITION_TP));
            }
         }
      }
   }
    
}
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---

   return(INIT_SUCCEEDED);
//---

  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---



ApplyTrailingStop();
   
  }
//+------------------------------------------------------------------+
